import type { ValueObject } from '@core/shared/domain/ValueObject';
import { RacingDomainValidationError } from '../errors/RacingDomainError';

export class TrackLength implements ValueObject<number> {
  private constructor(private readonly value: number) {}

  get props(): number {
    return this.value;
  }

  static create(value: number): TrackLength {
    if (value <= 0) {
      throw new RacingDomainValidationError('Track length must be positive');
    }
    return new TrackLength(value);
  }

  toNumber(): number {
    return this.value;
  }

  equals(other: ValueObject<number>): boolean {
    return this.value === other.props;
  }
}